"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=exports.privateApi=void 0;var types=_interopRequireWildcard(require("@babel/types")),_arguments=_interopRequireDefault(require("./arguments")),_logging=_interopRequireDefault(require("./logging")),_sourceFile=_interopRequireDefault(require("./source-file")),_constants=_interopRequireDefault(require("./constants"));function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _getRequireWildcardCache(){if("function"!=typeof WeakMap)return null;var cache=new WeakMap;return _getRequireWildcardCache=function(){return cache},cache}function _interopRequireWildcard(obj){if(obj&&obj.__esModule)return obj;if(null===obj||"object"!=typeof obj&&"function"!=typeof obj)return{default:obj};var cache=_getRequireWildcardCache();if(cache&&cache.has(obj))return cache.get(obj);var newObj={},hasPropertyDescriptor=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var key in obj)if(Object.prototype.hasOwnProperty.call(obj,key)){var desc=hasPropertyDescriptor?Object.getOwnPropertyDescriptor(obj,key):null;desc&&(desc.get||desc.set)?Object.defineProperty(newObj,key,desc):newObj[key]=obj[key]}return newObj.default=obj,cache&&cache.set(obj,newObj),newObj}const privateApi={};exports.privateApi=privateApi;const service={};privateApi.hasLogging=(bodyNode,state)=>{const isExpressionStatement=types.isExpressionStatement(bodyNode);if(!isExpressionStatement)return!1;const expression=bodyNode.expression,isCallExpression=types.isCallExpression(expression);if(!isCallExpression)return!1;const callee=expression.callee,isMemberExpression=types.isMemberExpression(callee);if(!isMemberExpression)return!1;const calleeObject=callee.object,isIdentifier=types.isIdentifier(calleeObject);if(!isIdentifier)return!1;const loggerName=service.getLoggerName(state);return calleeObject.name===loggerName},privateApi.canBeAdded=(path,state)=>{const isBlockStatement=types.isBlockStatement(path);if(!isBlockStatement)return!1;const blockBody=path.node.body,foundLogger=blockBody.find(bodyNode=>privateApi.hasLogging(bodyNode,state));return!foundLogger},privateApi.getPathForInsert=path=>{const insertPath=path.get("body"),isBlockStatement=types.isBlockStatement(insertPath);if(isBlockStatement)return insertPath;const isArrowFunctionExpression=types.isArrowFunctionExpression(insertPath);return isArrowFunctionExpression?privateApi.getPathForInsert(insertPath):void 0},privateApi.getLocation=path=>{const{loc:{start:{column,line}={}}={}}=path.node||{};return{column,line}},privateApi.getName=path=>{var _NumberisInteger=Number.isInteger;const isCatchClause=types.isCatchClause(path);if(isCatchClause)return"catchClause";const{container={},node={},parent={}}=path;if(node.id)return node.id.name;if(container.id)return container.id.name;if(parent.left&&parent.left.property)return parent.left.property.name;if(parent.left&&parent.left.name)return parent.left.name;const{key:nodeKey={}}=node;if(nodeKey&&nodeKey.name)return nodeKey.name;const{key:parentKey={}}=parent;if(parentKey&&parentKey.name)return parentKey.name;const{callee:{property}={}}=parent;return property&&"catch"===property.name?_constants.default.MEMBER_EXPRESSION_CATCH:path.inList&&_NumberisInteger(path.key)?`array-item-${path.key}`:void 0},privateApi.testMatcher=(matcher,value)=>matcher&&matcher.test(value)||!1,privateApi.testLogLevelMatcher=(levels,levelsByPriority,knownData)=>logLevel=>{if(logLevel===levelsByPriority[0])return!1;const logLevelSettings=levels[logLevel],matchOnSource=privateApi.testMatcher(logLevelSettings.matchSourceRegExp,knownData.source);return matchOnSource?matchOnSource:privateApi.testMatcher(logLevelSettings.matchFunctionNameRegExp,knownData.name)},privateApi.getDefaultLogLevelName=(path,state,knownData)=>{const{levelForMemberExpressionCatch,levelForTryCatch,levels}=state.babelPluginLoggerSettings.loggingData,isCatchClause=types.isCatchClause(path);if(isCatchClause)return levelForTryCatch;if(knownData.name===_constants.default.MEMBER_EXPRESSION_CATCH)return levelForMemberExpressionCatch;const loggingMethods=_logging.default.getLevels(),verboseLoggingMethod=loggingMethods.log,verboseLoggingSettings=levels[verboseLoggingMethod];return verboseLoggingSettings.matchSource||verboseLoggingSettings.matchFunctionName?"":verboseLoggingMethod},privateApi.getLoggingMethod=(path,state,knownData,defaultLogLevelName)=>{const{levels}=state.babelPluginLoggerSettings.loggingData,levelsByPriority=_logging.default.getLevelsByPriority();let newLoglevelName="";defaultLogLevelName!==levelsByPriority[0]&&(newLoglevelName=levelsByPriority.find(privateApi.testLogLevelMatcher(levels,levelsByPriority,knownData)));const logLevelName=newLoglevelName||defaultLogLevelName;return levels[logLevelName]&&levels[logLevelName].methodName},privateApi.getLogLevel=(path,state,knownData)=>{const logLevelName=privateApi.getDefaultLogLevelName(path,state,knownData);return privateApi.getLoggingMethod(path,state,knownData,logLevelName)},privateApi.insertLogging=(path,insertPath,state,partialData)=>{const source=_sourceFile.default.get(state),knownData={column:partialData.column,line:partialData.line,name:partialData.name,source},useLogLevel=privateApi.getLogLevel(path,state,knownData);useLogLevel&&insertPath.unshiftContainer("body",types.expressionStatement(types.callExpression(types.memberExpression(types.identifier(service.getLoggerName(state)),types.identifier(useLogLevel)),_arguments.default.get(path,state,knownData))))},service.getLoggerName=state=>state.babelPluginLoggerSettings.loggingData.name,service.getLoggerSource=state=>state.babelPluginLoggerSettings.loggingData.source,service.isValidPathAndState=(path,state)=>{if(path.node._generated)return!1;const{filename}=state.file.opts,{sourceMatcher,sourceExcludeMatcher}=state.babelPluginLoggerSettings,allowFromSource=sourceMatcher.test(filename);if(!allowFromSource)return!1;const excludeFromSource=sourceExcludeMatcher.test(filename);return!excludeFromSource},service.addLogger=(path,state)=>{const name=privateApi.getName(path);if(!name)return!1;const insertPath=privateApi.getPathForInsert(path);if(!insertPath)return!1;const{column,line}=privateApi.getLocation(insertPath);if(!(column!==void 0&&line!==void 0))return!1;const loggerCanBeAdded=privateApi.canBeAdded(insertPath,state);return!!loggerCanBeAdded&&(privateApi.insertLogging(path,insertPath,state,{column,line,name}),!0)};var _default=service;exports.default=_default;